import xmllib
import string

from threading import *
from Element import Element

class XMLInStream(xmllib.XMLParser):
    def __init__(self, file):
	xmllib.XMLParser.__init__(self)
	self.__file = file
	self.__data = []
	self.__cdata = []
	self.__stack = []
	self.doReset = 1
	self.dataReady = Semaphore(0)
	self.dataLock = Lock()
	self.readThread = Thread(target = self.read)
	self.readThread.setDaemon(1)
	
	self.elements = {"jabber":(self.startJabber, self.endJabber),
			 "message":(self.startMessage, self.endMessage),
			 "status":(self.startStatus, self.endStatus),
			 "roster":(self.startRoster, self.endRoster),
			 "from":(self.startFrom, self.endFrom),
			 "say":(self.startSay, self.endSay),
			 "thread":(self.startThread, self.endThread),
			 "priority":(self.startPriority, self.endPriority),
			 "subject":(self.startSubject, self.endSubject),
			 "ext":(self.startExt, self.endExt),
			 "icon":(self.startIcon, self.endIcon),
			 "group":(self.startGroup, self.endGroup),
			 "login":(self.startLogin, self.endLogin),
			 "user":(self.startUser, self.endUser),
			 "pass":(self.startPass, self.endPass),
			 "nick":(self.startNick, self.endNick),
			 "to":(self.startTo, self.endTo),
			 "add":(self.startAdd, self.endAdd),
			 "del":(self.startDel, self.endDel),
			 "get":(self.startGet, None)}
	self.attributes = {"jabber":{"version":"???", "protocol":"???"},
			   "message":{"type":"???"},
			   "status":{"type":"???"},
			   "say":{"type":"???"},
			   "group":{"name":"???"},
			   "add":{"group":"???"},
			   "del":{"group":"???"},
			   "get":{"group":"???"}}
	self.readThread.start()

    def read(self):
	while 1: #Will this work right, xor do I need to go by character?
	    if self.doReset:
		self.doReset = 0
		self.reset()
	    l = self.__file.readline()
	    self.feed(l)

    def getNext(self):
	self.dataReady.acquire()
	self.dataLock.acquire()
	r = self.__data[0]
	self.__data = self.__data[1:]
	self.dataLock.release()
	return r
    
    def handle_data(self, data):
	if len(self.__cdata) > 0:
	    s = self.__cdata[-1]
	    self.__cdata[-1] = s + data
    
    def startTag(self, type, attr):
	t = Element(type)
	t.update(attr)
	self.__stack.append(t)
	self.__cdata.append("")
	return t

    def endTag(self):
	t = self.__stack.pop()
	d = self.__cdata.pop()
	t.cdata = string.strip(d)
	if len(self.__stack) == 0:
	    self.dataLock.acquire()
	    self.__data.append(t)
	    self.dataLock.release()
	    self.dataReady.release()
	    self.doReset = 1
	else:
	    self.__stack[-1].addChild(t)
    
    def startJabber(self, attr):
	self.startTag("jabber", attr)
	
    def endJabber(self):
	self.endTag()

    def startMessage(self, attr):
	self.startTag("message", attr)

    def endMessage(self):
	self.endTag()

    def startStatus(self, attr):
	self.startTag("status", attr)

    def endStatus(self):
	self.endTag()

    def startRoster(self, attr):
	self.startTag("roster", attr)

    def endRoster(self):
	self.endTag()

    def startFrom(self, attr):
	self.startTag("from", attr)

    def endFrom(self):
	self.endTag()

    def startSay(self, attr):
	self.startTag("say", attr)

    def endSay(self):
	self.endTag()

    def startThread(self, attr):
	self.startTag("thread", attr)

    def endThread(self):
	self.endTag()

    def startPriority(self, attr):
	self.startTag("priority", attr)

    def endPriority(self):
	self.endTag()

    def startSubject(self, attr):
	self.startTag("subject", attr)

    def endSubject(self):
	self.endTag()

    def startExt(self, attr):
	self.startTag("ext", attr)

    def endExt(self):
	self.endTag()

    def startIcon(self, attr):
	self.startTag("icon", attr)

    def endIcon(self):
	self.endTag()

    def startGroup(self, attr):
	self.startTag("group", attr)

    def endGroup(self):
	self.endTag()

    def startLogin(self, attr):
	self.startTag("login", attr)

    def endLogin(self):
	self.endTag()

    def startUser(self, attr):
	self.startTag("user", attr)

    def endUser(self):
	self.endTag()

    def startPass(self, attr):
	self.startTag("pass", attr)

    def endPass(self):
	self.endTag()

    def startNick(self, attr):
	self.startTag("nick", attr)

    def endNick(self):
	self.endTag()

    def startTo(self, attr):
	self.startTag("to", attr)

    def endTo(self):
	self.endTag()

    def startAdd(self, attr):
	self.startTag("add", attr)

    def endAdd(self):
	self.endTag()

    def startDel(self, attr):
	self.startTag("del", attr)

    def endDel(self):
	self.endTag()

    def startGet(self, attr):
	self.startTag("get", attr)
	self.endTag()
