from threading import *
from Element import Element

XMLHEADER='<?xml version="1.0" standalone="yes"?>\n'

class XMLOutStream:
    def __init__(self, file):
	self.__file = file
	self.__data = []
	self.dataReady = Semaphore(0)
	self.dataLock = Lock()
	self.writeThread = Thread(target = self.write)
	self.writeThread.setDaemon(1)
	self.writeThread.start()
	
    def output(self, element, depth = 0):
	f = self.__file
#	f.write("%s---%s---%s---\n" % (element.type,
#                                      element.cdata,
#                                      str(element)))
	f.write(("\t" * depth) + ("<%s" % element.type))
	for i in element.items():
	    if i[1] == "???": continue
	    f.write(' %s="%s"' % (i[0], i[1]))
	if len(element.children) == 0 and len(element.cdata) == 0:
	    f.write("/>\n")
	    return None
	f.write(">\n")
	if len(element.cdata) > 0:
	    f.write("%s%s\n" % (("\t" * (depth + 1)), element.cdata))
	for e in element.children:
	    self.output(e, depth + 1)
	f.write("%s</%s>\n" % (("\t" * depth), element.type))
    
    def write(self):
	while 1:
	    self.dataReady.acquire()
	    self.dataLock.acquire()
	    e = self.__data[0]
	    self.__data = self.__data[1:]
	    self.dataLock.release()
	    self.__file.write(XMLHEADER)
	    self.output(e)
    
    def putNext(self, element):
	self.dataLock.acquire()
	self.__data.append(element)
	self.dataLock.release()
	self.dataReady.release()
